Index: src/Fl_Menu_.cxx
===================================================================
--- src/Fl_Menu_.cxx	(revision 6732)
+++ src/Fl_Menu_.cxx	(working copy)
@@ -188,6 +188,12 @@
   textsize(FL_NORMAL_SIZE);
   textcolor(FL_FOREGROUND_COLOR);
   down_box(FL_NO_BOX);
+
+#ifdef FL_HAVE_MSAA
+  // Initialize MSAA stuff
+  msaa_menu_items_  = 0;
+  msaa_menu_popups_ = 0;
+#endif // FL_HAVE_MSAA
 }
 
 /**
@@ -248,6 +254,9 @@
   Menus must not be cleared during a callback to the same menu.
 */
 void Fl_Menu_::clear() {
+#ifdef FL_HAVE_MSAA
+  msaa_menu_clear();
+#endif // FL_HAVE_MSAA
   if (alloc) {
     if (alloc>1) for (int i = size(); i--;)
       if (menu_[i].text) free((void*)menu_[i].text);
@@ -261,6 +270,715 @@
   }
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+// Specialized MSAA proxy for Fl_Menu_ object
+class Fl_Menu_Proxy : public Fl_Msaa_Proxy
+{
+private:
+  Fl_Menu_Proxy* GetChild(int id);
+
+protected:
+  int  mPos;		// Index to menu's first child in menu bar
+  bool mIsPopup;	// Is this a proxy for menu item container
+
+public:
+  Fl_Menu_Proxy(Fl_Widget* o, int pos, bool isPopup) :
+      Fl_Msaa_Proxy(o), mPos(pos), mIsPopup(isPopup)  {}
+
+  // IAccessible implementation
+  HRESULT STDMETHODCALLTYPE get_accParent(IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accChildCount(long*);
+  HRESULT STDMETHODCALLTYPE get_accChild(VARIANT, IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accName(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accValue(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accDescription(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accRole(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accState(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accHelp(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accHelpTopic(BSTR*, VARIANT, long*);
+  HRESULT STDMETHODCALLTYPE get_accKeyboardShortcut(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accFocus(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accSelection(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accDefaultAction(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE accSelect(long, VARIANT);
+  HRESULT STDMETHODCALLTYPE accLocation(long*, long*, long*, long*, VARIANT);
+  HRESULT STDMETHODCALLTYPE accNavigate(long, VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accHitTest(long, long, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accDoDefaultAction(VARIANT);
+  HRESULT STDMETHODCALLTYPE put_accName(VARIANT, BSTR);
+  HRESULT STDMETHODCALLTYPE put_accValue(VARIANT, BSTR);
+};
+
+
+static int
+get_child_count(const Fl_Menu_Item* item)
+{
+  int count = 0;
+  while (item->label())
+  {
+    item = item->next();
+    count++;
+  }
+  return count;
+}
+
+
+Fl_Menu_Proxy*
+Fl_Menu_Proxy::GetChild(int id)
+{
+  // Proxy for submenu item contains only a popup
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!mIsPopup)  return menubar->msaa_menu_proxy(mPos, true);
+
+  // Get proxy item only for sub-menu
+  const Fl_Menu_Item* child = menubar->msaa_menu_get_item(mPos, id);
+  if (!child)  return NULL;
+  if (!(child->flags & FL_SUBMENU))  return NULL;
+  return menubar->msaa_menu_proxy((child - menubar->menu()) + 1, false);
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accParent(
+    /* [retval][out] */ IDispatch** ppdispParent)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!ppdispParent)  return E_INVALIDARG;
+  if (mPos == 0)  return Fl_Msaa_Proxy::get_accParent(ppdispParent);
+  *ppdispParent = NULL;
+
+  Fl_Msaa_Proxy* proxy;
+  if (mIsPopup)
+  {
+    // Parent of pop-up menu is corresponding item
+    proxy = menubar->msaa_menu_proxy(mPos, false);
+  }
+  else
+  {
+    // Parent of menu item is pop-up menu
+    proxy = menubar->msaa_menu_proxy(menubar->msaa_menu_parent(mPos), true);
+  }
+
+  if (!proxy)  return S_FALSE;
+  proxy->QueryInterface(IID_IDispatch, (void**)ppdispParent);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accChildCount(
+    /* [retval][out] */ long* pcountChildren)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pcountChildren)  return E_INVALIDARG;
+  if (mIsPopup)
+    *pcountChildren = get_child_count(menubar->menu() + mPos);
+  else
+    *pcountChildren = 1;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accChild(
+    /* [in] */ VARIANT varChild,
+    /* [retval][out] */ IDispatch** ppdispChild)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (varChild.vt != VT_I4)  return E_INVALIDARG;
+  if (!ppdispChild)  return E_INVALIDARG;
+  *ppdispChild = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+
+  long max_id = (mIsPopup ? get_child_count(menubar->menu() + mPos) : 1);
+  if (id < 0 || id > max_id)  return E_INVALIDARG;
+
+  Fl_Menu_Proxy* proxy = GetChild(id);
+  if (!proxy)  return S_FALSE;
+  proxy->QueryInterface(IID_IDispatch, (void**)ppdispChild);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accName(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszName)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pszName)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::get_accName(varChild, pszName);
+  *pszName = NULL;
+
+  const Fl_Menu_Item* item = menubar->msaa_menu_get_item(mPos, id);
+  if (!item)  return E_INVALIDARG;
+  if (!item->msaa_name(pszName))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszValue)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pszValue)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::get_accValue(varChild, pszValue);
+  *pszValue = NULL;
+
+  const Fl_Menu_Item* item = menubar->msaa_menu_get_item(mPos, id);
+  if (!item)  return E_INVALIDARG;
+  if (!item->msaa_value(pszValue))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accDescription(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDescription)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDescription)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::get_accDescription(varChild, pszDescription);
+  *pszDescription = NULL;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accRole(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarRole)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarRole)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::get_accRole(varChild, pvarRole);
+
+  pvarRole->vt   = VT_I4;
+  if (mPos == 0)
+    pvarRole->lVal = ROLE_SYSTEM_MENUBAR;
+  else if (mIsPopup && (id == 0))
+    pvarRole->lVal = ROLE_SYSTEM_MENUPOPUP;
+  else 
+    pvarRole->lVal = ROLE_SYSTEM_MENUITEM;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accState(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarState)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarState)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  pvarState->vt = VT_I4;
+  if ((mPos == 0) || !mIsPopup || (id != 0))
+    pvarState->lVal = 0;
+  else
+    pvarState->lVal = STATE_SYSTEM_INVISIBLE;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accHelp(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszHelp)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelp)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::get_accHelp(varChild, pszHelp);
+  *pszHelp = NULL;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accHelpTopic(
+    /* [out] */ BSTR* pszHelpFile,
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ long* pidTopic)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelpFile)  return E_INVALIDARG;
+  if (!pidTopic)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::get_accHelpTopic(pszHelpFile, varChild, pidTopic);
+  *pszHelpFile = NULL;
+  *pidTopic = 0;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accKeyboardShortcut(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszKeyboardShortcut)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pszKeyboardShortcut)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::get_accKeyboardShortcut(
+    	varChild, pszKeyboardShortcut);
+  *pszKeyboardShortcut = NULL;
+
+  // Popup proxy has no shortcut
+  if (mIsPopup && (id == 0))  return S_FALSE;
+  if (!menubar->msaa_menu_shortcut(mPos, id, pszKeyboardShortcut))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accFocus(
+    /* [retval][out] */ VARIANT *pvarChild)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+  return S_FALSE;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accSelection(
+    /* [retval][out] */ VARIANT* pvarChildren)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChildren)  return E_INVALIDARG;
+  pvarChildren->vt = VT_EMPTY;
+  return S_FALSE;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::get_accDefaultAction(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDefaultAction)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDefaultAction)  return E_INVALIDARG;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  *pszDefaultAction = NULL;
+
+  if (!mIsPopup || (mIsPopup && (id == 0)))  return S_FALSE;
+  const Fl_Menu_Item* item = menubar->msaa_menu_get_item(mPos, id);
+  if (!item)  return E_INVALIDARG;
+  fl_str_to_bstr("Execute", -1, pszDefaultAction);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::accSelect(
+    /* [in] */ long flagsSelect,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  return S_FALSE;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::accLocation(
+    /* [out] */ long* pxLeft,
+    /* [out] */ long* pyTop,
+    /* [out] */ long* pcxWidth,
+    /* [out] */ long* pcyHeight,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pxLeft || !pyTop || !pcxWidth || !pcyHeight)  return E_INVALIDARG;
+  *pxLeft    = 0;
+  *pyTop     = 0;
+  *pcxWidth  = 0;
+  *pcyHeight = 0;
+
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > get_child_count(menubar->menu() + mPos))
+    return E_INVALIDARG;
+  if (!menubar->msaa_menu_location(mPos, id,
+      pxLeft, pyTop, pcxWidth, pcyHeight))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::accNavigate(
+    /* [in] */ long navDir,
+    /* [optional][in] */ VARIANT varStart,
+    /* [retval][out] */ VARIANT* pvarEndUpAt)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarEndUpAt)  return E_INVALIDARG;
+  pvarEndUpAt->vt = VT_EMPTY;
+  long id = (varStart.vt == VT_I4 ? varStart.lVal : 0);
+  if ((id != 0) &&
+      ((navDir == NAVDIR_FIRSTCHILD) || (navDir == NAVDIR_LASTCHILD)))
+    return S_FALSE;
+
+  // Handle navigation relative to menu item itself
+  if ((id == 0) &&
+      (navDir != NAVDIR_FIRSTCHILD) && (navDir != NAVDIR_LASTCHILD))
+  {
+    // Handle navigation relative to top menubar
+    if (mPos == 0)
+      return Fl_Msaa_Proxy::accNavigate(navDir, varStart, pvarEndUpAt);
+
+    // Forward request to parent menu
+    VARIANT self;
+    self.vt = VT_I4;
+    Fl_Msaa_Proxy* proxy;
+    if (mIsPopup)
+    {
+      proxy = menubar->msaa_menu_proxy(mPos, false);
+      self.lVal = 1;
+    }
+    else
+    {
+      proxy = menubar->msaa_menu_proxy(menubar->msaa_menu_parent(mPos), true);
+      self.lVal = menubar->msaa_menu_child_id(mPos);
+    }
+    if (!proxy)  return S_FALSE;
+    return proxy->accNavigate(navDir, self, pvarEndUpAt);
+  }
+
+  // Handle navigation between menu items
+  long max_id = (mIsPopup ? get_child_count(menubar->menu() + mPos) : 1);
+  if (max_id < 1)  return S_FALSE;
+  long dst;
+  switch (navDir)
+  {
+    case NAVDIR_FIRSTCHILD:
+      dst = 1;
+      break;
+    case NAVDIR_LASTCHILD:
+      dst = max_id;
+      break;
+    case NAVDIR_PREVIOUS:
+      if (id == 1)  return S_FALSE;
+      dst = id - 1;
+      break;
+    case NAVDIR_NEXT:
+      if (id == max_id)  return S_FALSE;
+      dst = id + 1;
+      break;
+
+    // Spatial navigation not implemented
+    case NAVDIR_UP:	// Fall through
+    case NAVDIR_DOWN:	// Fall through
+    case NAVDIR_LEFT:	// Fall through
+    case NAVDIR_RIGHT:	// Fall through
+    default:
+      return S_FALSE;
+  }
+
+  // Lookup child proxy
+  Fl_Msaa_Proxy* proxy = GetChild(dst);
+  if (!proxy)
+  {
+    pvarEndUpAt->vt   = VT_I4;
+    pvarEndUpAt->lVal = dst;
+  }
+  else
+  {
+    pvarEndUpAt->vt = VT_DISPATCH;
+    proxy->QueryInterface(IID_IDispatch, (void**)&pvarEndUpAt->pdispVal);
+  }
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::accHitTest(
+    /* [in] */ long xLeft,
+    /* [in] */ long yTop,
+    /* [retval][out] */ VARIANT* pvarChild)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  // Make sure the point is inside this widget
+  long X, Y, W, H;
+  if (!menubar->msaa_menu_location(mPos, 0, &X, &Y, &W, &H))  return S_FALSE;
+  if ((xLeft < X) || (xLeft >= (X + W)))  return S_FALSE;
+  if ((yTop < Y) || (yTop >= (Y + H)))  return S_FALSE;
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = 0;
+
+  // Check child elements from top to bottom
+  for (int n = get_child_count(menubar->menu() + mPos);  n > 0;  --n)
+  {
+    // Obtain location through proxy first, but fall back to function call
+    Fl_Msaa_Proxy* proxy = GetChild(n);
+    if (proxy && (proxy->accLocation(&X, &Y, &W, &H, *pvarChild) != S_OK))
+      continue;
+    else if (!proxy && !menubar->msaa_menu_location(mPos, n, &X, &Y, &W, &H))
+      continue;
+
+    // Make sure point is inside child object
+    if ((xLeft < X) || (xLeft >= (X + W)))  continue;
+    if ((yTop < Y) || (yTop >= (Y + H)))  continue;
+
+    // Setup result
+    if (proxy)
+    {
+      pvarChild->vt = VT_DISPATCH;
+      proxy->QueryInterface(IID_IDispatch, (void**)&pvarChild->pdispVal);
+    }
+    else
+    {
+      pvarChild->vt   = VT_I4;
+      pvarChild->lVal = n;
+    }
+    return S_OK;
+  }
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::accDoDefaultAction(
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::accDoDefaultAction(varChild);
+
+  if (!mIsPopup || (mIsPopup && (id == 0)))  return DISP_E_MEMBERNOTFOUND;
+  const Fl_Menu_Item* item = menubar->msaa_menu_get_item(mPos, id);
+  if (!item)  return E_INVALIDARG;
+  menubar->picked(item);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::put_accName(
+    /* [optional][in] */ VARIANT varChild,
+    /* [in] */ BSTR szName)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::put_accName(varChild, szName);
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Menu_Proxy::put_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [in] */ BSTR szValue)
+{
+  Fl_Menu_* menubar = (Fl_Menu_*)mpObj;
+  if (!menubar)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if ((mPos == 0) && (id == 0))
+    return Fl_Msaa_Proxy::put_accValue(varChild, szValue);
+
+  Fl_Menu_Item* item = (Fl_Menu_Item*)menubar->msaa_menu_get_item(mPos, id);
+  if (!item)  return E_INVALIDARG;
+  char* value = fl_bstr_to_str(szValue);
+  bool ok = item->msaa_put_value(value);
+  fl_free_str(value);
+  return (ok ? S_OK : DISP_E_MEMBERNOTFOUND);
+}
+
+
+/*-------------------------- Fl_Menu_ MSAA support ------------------------*/
+
+void
+Fl_Menu_::msaa_menu_clear()
+{
+  // Destroy cache of MSAA proxy
+  for (int i = size();  msaa_menu_items_ && i--;  )
+  {
+    Fl_Menu_Proxy* proxy;
+    if ((proxy = msaa_menu_items_[i]))
+    {
+      proxy->Detach();
+      proxy->Release();
+    }
+    if ((proxy = msaa_menu_popups_[i]))
+    {
+      proxy->Detach();
+      proxy->Release();
+    }
+  }
+  if (msaa_menu_items_)
+  {
+    free(msaa_menu_items_);
+    free(msaa_menu_popups_);
+    msaa_menu_items_  = 0;
+    msaa_menu_popups_ = 0;
+  }
+}
+
+
+Fl_Menu_Proxy*
+Fl_Menu_::msaa_menu_proxy(int pos, bool isPopup)
+{
+  // Do not cache root item
+  if (pos == 0)
+  {
+    if (!msaa_proxy_)
+    {
+      msaa_proxy_ = new Fl_Menu_Proxy(this, 0, true);
+      if (msaa_proxy_)  msaa_proxy_->AddRef();
+    }
+    return (Fl_Menu_Proxy*)msaa_proxy_;
+  }
+
+  // Create new storage for proxies if necessary
+  if (!msaa_menu_items_)
+  {
+    msaa_menu_items_  = (Fl_Menu_Proxy**)calloc(size(), sizeof(Fl_Menu_Proxy*));
+    msaa_menu_popups_ = (Fl_Menu_Proxy**)calloc(size(), sizeof(Fl_Menu_Proxy*));
+  }
+
+  // Determine required proxy type
+  Fl_Menu_Proxy** cache = isPopup ? msaa_menu_popups_ : msaa_menu_items_;
+  if (cache[pos])  return cache[pos];
+
+  // Create missing proxy
+  Fl_Menu_Proxy* proxy = new Fl_Menu_Proxy(this, pos, isPopup);
+  if (proxy)
+  {
+    proxy->AddRef();
+    cache[pos] = proxy;
+  }
+  return proxy;
+}
+
+
+Fl_Msaa_Proxy*
+Fl_Menu_::msaa_child(long id)
+{
+  if (id != 0)  return false;
+
+  // Create specialized proxy for top item
+  return msaa_menu_proxy(0, true);
+}
+
+
+const Fl_Menu_Item*
+Fl_Menu_::msaa_menu_get_item(int pos, long id)
+{
+  if ((pos == 0) && (id == 0))  return NULL;
+  if (id == 0)  return menu() + pos - 1;
+  const Fl_Menu_Item* item = menu() + pos;
+  for (;  id > 1;  --id, item = item->next());
+  return item;
+}
+
+
+int
+Fl_Menu_::msaa_menu_parent(int pos)
+{
+  --pos;
+  const Fl_Menu_Item* item = menu() + pos;
+  for (int nest = 1;  pos >= 0;  --pos, --item)
+  {
+    if (!item->label())  ++nest;
+    else if (item->flags & FL_SUBMENU)
+    {
+      --nest;
+      if (nest < 0)  break;
+    }
+  }
+  return pos + 1;
+}
+
+
+int
+Fl_Menu_::msaa_menu_child_id(int pos)
+{
+  --pos;
+  const Fl_Menu_Item* item = menu() + pos;
+  int id = 0;
+  for (int nest = 1;  pos >= 0;  --pos, --item)
+  {
+    if (!item->label())  ++nest;  
+    else
+    {
+      if (item->flags & FL_SUBMENU)
+      {
+	--nest;
+	if (nest < 0)  break;
+      }
+      if (nest == 0)  ++id;
+    }
+  }
+  return id;
+}
+
+
+bool
+Fl_Menu_::msaa_menu_location(int pos, long id,
+  long* X, long* Y, long* W, long* H)
+{
+  if ((pos != 0) || (id != 0))  return false;
+  return Fl_Widget::msaa_location(0, X, Y, W, H);
+}
+
+
+bool
+Fl_Menu_::msaa_menu_shortcut(int pos, long id, BSTR* bstr)
+{
+  const Fl_Menu_Item* item = msaa_menu_get_item(pos, id);
+  if (!item)  return false;
+  return item->msaa_shortcut(false, bstr);
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Menu_Bar.cxx
===================================================================
--- src/Fl_Menu_Bar.cxx	(revision 6732)
+++ src/Fl_Menu_Bar.cxx	(working copy)
@@ -73,6 +73,63 @@
   return 0;
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+long
+Fl_Menu_Bar::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_role(id);
+  return ROLE_SYSTEM_MENUBAR;
+}
+
+
+bool
+Fl_Menu_Bar::msaa_menu_location(int pos, long id,
+  long* X, long* Y, long* W, long* H)
+{
+  bool on_menubar = false;
+  if (pos != 0)  on_menubar = ((id == 0) && (msaa_menu_parent(pos) == 0));
+
+  // Return the size of the widget for top level menubar
+  if (!Fl_Widget::msaa_location(0, X, Y, W, H))  return false;
+  if ((pos == 0) && (id == 0))  return true;
+
+  // Return location only for top-most items
+  if (on_menubar)  id = msaa_menu_child_id(pos);
+  else if (pos != 0)  return false;
+
+  // NOTE: This must match algorithm in draw()
+  const Fl_Menu_Item* m = menu()->first();
+  for (*X += 3;  --id;  m = m->next())
+  {
+    if (!m->text)  return false;
+    *X += m->measure(0, this) + 16;
+  }
+  *W = m->measure(0, this) + 12;
+  *Y += 3;
+  *H -= 6;
+  return true;
+}
+
+
+bool
+Fl_Menu_Bar::msaa_menu_shortcut(int pos, long id, BSTR* bstr)
+{
+  const Fl_Menu_Item* item = msaa_menu_get_item(pos, id);
+  if (!item)  return false;
+
+  bool on_menubar;
+  if (pos == 0)  on_menubar = true;
+  else  on_menubar = ((id == 0) && (msaa_menu_parent(pos) == 0));
+  return item->msaa_shortcut(on_menubar, bstr);
+}
+#endif // FL_HAVE_MSAA
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Window.cxx
===================================================================
--- src/Fl_Window.cxx	(revision 6732)
+++ src/Fl_Window.cxx	(working copy)
@@ -57,6 +57,11 @@
   size_range_set = 0;
   minw = maxw = minh = maxh = 0;
   callback((Fl_Callback*)default_callback);
+#ifdef FL_HAVE_MSAA
+  // Initialize MSAA stuff
+  msaa_caret_w_ = 0;
+  msaa_caret_h_ = 0;
+#endif
 }
 
 Fl_Window::Fl_Window(int X,int Y,int W, int H, const char *l)
@@ -178,6 +183,53 @@
 }
 
 
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+#include <FL/x.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+long
+Fl_Window::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Group::msaa_role(id);
+  return ROLE_SYSTEM_CLIENT;
+}
+
+
+long
+Fl_Window::msaa_state(long id)
+{
+  if (id != 0)  return Fl_Group::msaa_state(id);
+  return (STATE_SYSTEM_FOCUSABLE | (shown() ? 0 : STATE_SYSTEM_INVISIBLE));
+}
+
+
+void
+Fl_Window::msaa_set_caret(int X, int Y, int W, int H) const
+{
+  if (W < 0)  W = 0;
+  if (H < 0)  H = 0;
+
+  // Destroy old caret if it has a different size
+  if (W != msaa_caret_w_ || H != msaa_caret_h_)
+  {
+    Fl_Window* wnd = (Fl_Window*)this;
+    DestroyCaret();
+    wnd->msaa_caret_w_ = W;
+    wnd->msaa_caret_h_ = H;
+
+    // Create new caret if it has a definite size
+    if (W && H)  CreateCaret(fl_xid(this), NULL, W, H);
+  }
+
+  // Move caret only if it has a definite size
+  if (W && H)  SetCaretPos(X, Y);
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Value_Slider.cxx
===================================================================
--- src/Fl_Value_Slider.cxx	(revision 6732)
+++ src/Fl_Value_Slider.cxx	(working copy)
@@ -81,6 +81,34 @@
 			   shh-Fl::box_dh(box()));
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+bool
+Fl_Value_Slider::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (id == 0)  return Fl_Widget::msaa_location(0, X, Y, W, H);
+  if (!msaa_visible())  return false;
+
+  // Note: size calculations must match those in draw()
+  long sxx, syy, sww, shh;
+  Fl_Widget::msaa_location(0, &sxx, &syy, &sww, &shh);
+  if (horizontal()) {
+    sxx += 35; sww -= 35;
+  } else {
+    syy += 25; shh -= 25;
+  }
+  return msaa_slider_location(id,
+    sxx + Fl::box_dx(box()), syy + Fl::box_dy(box()),
+    sww - Fl::box_dw(box()), shh - Fl::box_dh(box()), X, Y, W, H);
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Value_Input.cxx
===================================================================
--- src/Fl_Value_Input.cxx	(revision 6732)
+++ src/Fl_Value_Input.cxx	(working copy)
@@ -142,6 +142,29 @@
     input.parent(0);   // *revert* ctor kludge!
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+long
+Fl_Value_Input::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_role(id);
+  return ROLE_SYSTEM_TEXT;
+}
+
+
+long
+Fl_Value_Input::msaa_state(long id)
+{
+  return (STATE_SYSTEM_FOCUSABLE | Fl_Widget::msaa_state(id));
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Button.cxx
===================================================================
--- src/Fl_Button.cxx	(revision 6732)
+++ src/Fl_Button.cxx	(working copy)
@@ -48,6 +48,9 @@
     value_ = v;
     if (box()) redraw();
     else redraw_label();
+#ifdef FL_HAVE_MSAA
+    msaa_notify(EVENT_OBJECT_STATECHANGE);
+#endif // FL_HAVE_MSAA
     return 1;
   } else {
     return 0;
@@ -185,6 +188,118 @@
   set_flag(SHORTCUT_LABEL);
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+bool
+Fl_Button::msaa_value(long id, BSTR* bstr)
+{
+  if (id != 0)  return Fl_Widget::msaa_value(id, bstr);
+  fl_str_to_bstr((value_ ? "1" : "0"), -1, bstr);
+  return true;
+}
+
+
+long
+Fl_Button::msaa_state(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_state(id);
+  long s = Fl_Widget::msaa_state(0);
+  switch(type())
+  {
+    case FL_TOGGLE_BUTTON:  // Fall through
+    case FL_RADIO_BUTTON:
+      if (value())  s |= STATE_SYSTEM_CHECKED;
+      return s;
+    default:
+      return s;
+  }
+}
+
+
+long
+Fl_Button::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_role(id);
+  switch (type())
+  {
+    case FL_TOGGLE_BUTTON:  return ROLE_SYSTEM_CHECKBUTTON;
+    case FL_RADIO_BUTTON:   return ROLE_SYSTEM_RADIOBUTTON;
+    default:                return ROLE_SYSTEM_PUSHBUTTON;
+  }
+}
+
+
+bool
+Fl_Button::msaa_action(long id, BSTR* bstr)
+{
+  if (id != 0)  return false;
+
+  // Return localized MSAA action
+  const char* action;
+  switch (type())
+  {
+    case FL_TOGGLE_BUTTON:  // Fall through
+    case FL_RADIO_BUTTON:   action = (value_ ? "Uncheck" : "Check");  break;
+    default:		    action = "Press";  break;
+  }
+  fl_str_to_bstr(action, -1, bstr);
+  return true;
+}
+
+
+bool 
+Fl_Button::msaa_do_action(long id)
+{
+  // NOTE: behaviour must match click handling in handle()
+  if (id != 0)  return false;
+
+  // Check for no change in button state
+  int newval = (type() == FL_RADIO_BUTTON ? 1 : !oldval);
+  if (newval == oldval) {
+    if (when() & FL_WHEN_NOT_CHANGED) do_callback();
+    return true;
+  }
+
+  // Simulate FL_PUSH, FL_DRAG and FL_RELEASE on button
+  set_changed();
+  if (type() == FL_RADIO_BUTTON) {
+    setonly();
+    redraw();
+    if (when() & FL_WHEN_CHANGED) do_callback();
+  }
+  else if (type() == FL_TOGGLE_BUTTON) {
+    oldval = value_ = newval;
+    redraw();
+    if (when() & FL_WHEN_CHANGED) do_callback();
+  }
+  else {
+    value_ = newval;
+    if (when() & FL_WHEN_CHANGED) do_callback();
+    value_ = oldval;
+    if (when() & FL_WHEN_CHANGED) do_callback();
+  }
+  if (when() & FL_WHEN_RELEASE) do_callback();
+  return true;
+}
+
+
+bool 
+Fl_Button::msaa_put_value(long id, const char* str)
+{
+  if (id != 0)  return false;
+  int v = atoi(str);
+  if (type() == FL_RADIO_BUTTON && v)  setonly();
+  else  value(v);
+  return true;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Menu_add.cxx
===================================================================
--- src/Fl_Menu_add.cxx	(revision 6732)
+++ src/Fl_Menu_add.cxx	(working copy)
@@ -265,6 +265,9 @@
   int value_offset = value_-menu_;
   menu_ = local_array; // in case it reallocated it
   if (value_) value_ = menu_+value_offset;
+#ifdef FL_HAVE_MSAA
+  msaa_menu_clear();
+#endif // FL_HAVE_MSAA
   return r;
 }
 
@@ -332,6 +335,9 @@
   }
   // MRS: "n" is the menu size(), which includes the trailing NULL entry...
   memmove(item, next_item, (menu_+n-next_item)*sizeof(Fl_Menu_Item));
+#ifdef FL_HAVE_MSAA
+  msaa_menu_clear();
+#endif // FL_HAVE_MSAA
 }
 
 //
